class Kurt extends KRobot config(USAR);

var float cachedLeftValue,cachedRightValue;
var rotator cachedCameraRot,initCameraRot;
var bool bGetInitCameraRot;
var config bool bAbsoluteCamera;

function ProcessCarInput()
{
	local float LeftValue,RightValue;
	local int CameraPan,CameraTilt;
	
	Super.ProcessCarInput();

	if (!bGetInitCameraRot) {
		initCameraRot = myCamera.Rotation;
		RemoteBot(Controller).LeftThrottle = 0.0;
		RemoteBot(Controller).RightThrottle = 0.0;
		RemoteBot(Controller).myCameraRotation = rot(0,0,0);
		bGetInitCameraRot = true;
	}

	LeftValue = RemoteBot(Controller).LeftThrottle*4000;
	RightValue = RemoteBot(Controller).RightThrottle*4000;
	if (cachedLeftValue!=LeftValue) {
		JointsControl[1].state = 1; // new command
		JointsControl[1].order = 1;
		JointsControl[1].value = LeftValue;
		JointsControl[3].state = 1; // new command
		JointsControl[3].order = 1;
		JointsControl[3].value = LeftValue;
		JointsControl[5].state = 1; // new command
		JointsControl[5].order = 1;
		JointsControl[5].value = LeftValue;
		bNewCommand = true;
		cachedLeftValue=LeftValue;
	}
	if (cachedRightValue!=RightValue) {
		JointsControl[0].state = 1; // new command
		JointsControl[0].order = 1;
		JointsControl[0].value = RightValue;
		JointsControl[2].state = 1; // new command
		JointsControl[2].order = 1;
		JointsControl[2].value = RightValue;
		JointsControl[4].state = 1; // new command
		JointsControl[4].order = 1;
		JointsControl[4].value = RightValue;
		bNewCommand = true;
		cachedRightValue=RightValue;
	}
	if (myCamera!=None) {
		if (RemoteBot(Controller).myCameraRotation.roll!=0) return;
		RemoteBot(Controller).myCameraRotation.roll = -1;
		if (RemoteBot(Controller).myCameraRotationOrder==1) {
			CameraTilt = RemoteBot(Controller).myCameraRotation.Pitch;
			CameraPan = RemoteBot(Controller).myCameraRotation.Yaw;
		} else if (!bAbsoluteCamera) {
			CameraTilt = -RemoteBot(Controller).myCameraRotation.Pitch;
			CameraPan = RemoteBot(Controller).myCameraRotation.Yaw;
		} else {
			CameraTilt = myCamera.Rotation.Pitch - initCameraRot.Pitch -Rotation.Pitch - RemoteBot(Controller).myCameraRotation.Pitch;
			CameraPan = RemoteBot(Controller).myCameraRotation.Yaw - myCamera.Rotation.Yaw + initCameraRot.Yaw + Rotation.Yaw;
			if (CameraTilt>65535) CameraTilt-=65535;
			else if (CameraTilt<-65535) CameraTilt+=65535;
			if (CameraTilt>32768) CameraTilt-=65535;
			else if (CameraTilt<-32768) CameraTilt+=65535;
			if (CameraPan>65535) CameraPan-=65535;
			else if (CameraPan<-65535) CameraPan+=65535;
			if (CameraPan>32768) CameraPan-=65535;
			else if (CameraPan<-32768) CameraPan+=65535;
		}
		if (CameraPan!=0 || RemoteBot(Controller).myCameraRotationOrder==1) {
			JointsControl[7].state = 1;
			//JointsControl[5].steer = 65535;
			JointsControl[7].order = RemoteBot(Controller).myCameraRotationOrder;
			JointsControl[7].value = CameraPan;
		}
		if (JointsControl[7].order==1)
			PanSpeed = CameraPan;
		else 
			PanSpeed = MotorSpeed;
		if (CameraTilt!=0 || RemoteBot(Controller).myCameraRotationOrder==1) {
			JointsControl[8].state = 1;
			//JointsControl[6].steer = 65535;
			JointsControl[8].order = RemoteBot(Controller).myCameraRotationOrder;
			JointsControl[8].value = CameraTilt;
		}
		if (JointsControl[8].order==1)
			TiltSpeed = CameraTilt;
		else 
			TiltSpeed = MotorSpeed;
		bNewCommand = true;
	}
	//bReady = true;
}

defaultproperties
{
	bDebug=false
	StaticMesh=StaticMesh'Kurt_Meshes.Robot.Kurt'
	//DrawScale=1.0					// 1 cm = 2 UU / 1 UU = 5 mm
	DrawScale=1.25					// 1 UU = 4mm
	DrawScale3D=(X=1.0,Y=1.0,Z=1.0)

    Begin Object Class=KarmaParamsRBFull Name=KParams0
        KInertiaTensor(0)=20.000000
        KInertiaTensor(3)=30.000000
        KInertiaTensor(5)=48.000000
        KCOMOffset=(X=0.000000,Z=-15.000000)
        KLinearDamping=0.000000
        KAngularDamping=0.000000
        KStartEnabled=True
        bHighDetailOnly=False
        bClientOnly=False
        bKDoubleTickRate=True
        KFriction=1.600000
        Name="KParams0"
    End Object
    KParams=KarmaParamsRBFull'USARBot.Kurt.KParams0'

    Begin Object Class=KarmaParamsRBFull Name=KarmaParams2
    	KInertiaTensor(0)=1.8
        KInertiaTensor(1)=0
        KInertiaTensor(2)=0
        KInertiaTensor(3)=1.8
        KInertiaTensor(4)=0
        KInertiaTensor(5)=1.8
        KAngularDamping=0
        KLinearDamping=0
        bHighDetailOnly=False
        bClientOnly=False
        bKDoubleTickRate=True
        Name="KarmaParams2"
    End Object

	JointParts(0)=(PartName="LeftFWheel",PartClass=class'USARBot.KDTire',PartStaticMesh=StaticMesh'BulldogMeshes.Simple.S_RearWheel',DrawScale=0.1,KParams=KarmaParams'USARBot.ATRVJr.KarmaParams2',DrawScale3D=(X=1.0,Y=0.6,Z=1.0),bSteeringLocked=True,bSuspensionLocked=true,Parent="",JointClass=class'KCarWheelJoint',ParentPos=(X=20,Y=35.0,Z=-10.0),ParentRot=(Yaw=16384),ParentAxis=(Z=1.0),SelfPos=(Z=0.0),SelfAxis=(Z=1.0))
	JointParts(1)=(PartName="RightFWheel",PartClass=class'USARBot.KDTire',PartStaticMesh=StaticMesh'BulldogMeshes.Simple.S_RearWheel',DrawScale=0.1,KParams=KarmaParams'USARBot.ATRVJr.KarmaParams2',DrawScale3D=(X=1.0,Y=0.6,Z=1.0),bSteeringLocked=True,bSuspensionLocked=true,Parent="",JointClass=class'KCarWheelJoint',ParentPos=(X=20,Y=-35.0,Z=-10.0),ParentRot=(Yaw=49152),ParentAxis=(Z=1.0),SelfPos=(Z=0.0),SelfAxis=(Z=1.0))
	JointParts(2)=(PartName="RearWheel",PartClass=class'USARBot.KDTire',PartStaticMesh=StaticMesh'BulldogMeshes.Simple.S_RearWheel',DrawScale=0.03,KParams=KarmaParams'USARBot.ATRVJr.KarmaParams2',DrawScale3D=(X=1.0,Y=0.6,Z=1.0),bSteeringLocked=True,bSuspensionLocked=true,Parent="",JointClass=class'KCarWheelJoint',ParentPos=(X=-35,Y=0.0,Z=-15.0),ParentRot=(Yaw=16384),ParentAxis=(Z=1.0),SelfPos=(Z=0.0),SelfAxis=(Z=1.0))
}
